#include <iostream>



using namespace std;


class Array1D
{
private:
	int* arr1;
	int len1;
public:
	Array1D(int n = 0) : len1(n)
	{
		printf("arr1   ");
		arr1 = new int[n];
		int i=0;
		for(i=0; i<n; i++)
		{
			printf("%x    ", &arr1[i]);
		}
		printf("\n");
	}
	int& operator[](int index)
	{
		if (index < 0 || index >= len1)
		{
			cout << "Out of index range" << endl;
			exit(0);
		}
		return *(&arr1[index]);
	}
	int Getlen()
	{
		return len1;
	}
	~Array1D()
	{
		cout << "Array1" << endl;
		delete[]arr1;
	}
};


class Array2D
{
private:
	Array1D* arr2;
	int len;
public:
	Array2D(int n1, int n2) :len(n1)
	{
		// operator new[]  ȣϿ ʿ ŭ ޸𸮸 Ҵϰ
		arr2 = reinterpret_cast<Array1D*>(operator new[](n1 * sizeof(Array1D)));
		printf("arr2   %x\n", arr2);
		for (int i = 0; i < n1; i++)
		{
			// ġ  new ȣϿ ٷ  ڸ Array1D ü մϴ.
			// ⼭ ڰ ȣ˴ϴ.
			printf("arr2----prev\n");
			printf("arr2    new      %x\n", new (arr2 + i) Array1D(n2));
			printf("arr2----next\n");
		}
	}
	Array1D& operator[](int index)
	{
		if (index < 0 || index >= len)
		{
			cout << "Out of index range" << endl;
			exit(0);
		}
		return arr2[ index ];
	}
	int Getlen()
	{
		return len;
	}
	~Array2D()
	{
		cout << "Array2" << endl;
		// Ҹ  .     ü Ҹڸ  ȣݴϴ.
		for (int i = 0;i < len;i++)
		{
			arr2[i].~Array1D();
		}
		//   operator delete[] ȣϿ ޸𸮸 մϴ.
		operator delete[](arr2);
	}
};


int MAX_X = 4;
int MAX_Y = 2;


int main(int argc, char** argv) 
{

	Array2D arr(MAX_X, MAX_Y);
 
 	int cnt=0;
	for (int k = 0; k < MAX_X; k++)
	{
		for (int p = 0; p < MAX_Y; p++)
		{
			arr[k][p] = cnt;
			printf("main   %x    %x    %d\n", &arr[k], &arr[k][p], cnt);
			cnt++;
		}
	}
	cout << arr[1][1] << endl;
	return 0;
}




#if 0

2, 4 

arr2   3d3a68
arr2----prev
arr1   3d3ab8    3d3abc    3d3ac0    3d3ac4
arr2    new      3d3a68
arr2----next
arr2----prev
arr1   3d3f28    3d3f2c    3d3f30    3d3f34
arr2    new      3d3a70
arr2----next
main   3d3a68    3d3ab8    0
main   3d3a68    3d3abc    1
main   3d3a68    3d3ac0    2
main   3d3a68    3d3ac4    3
main   3d3a70    3d3f28    4
main   3d3a70    3d3f2c    5
main   3d3a70    3d3f30    6
main   3d3a70    3d3f34    7
5
Array2
Array1
Array1

--------------------------------
Process exited after 0.6239 seconds with return value 0
Ϸ ƹ Ű ʽÿ . . .



4, 2 


arr2   3d3ed8
arr2----prev
arr1   3d3f28    3d3f2c
arr2    new      3d3ed8
arr2----next
arr2----prev
arr1   3d3f38    3d3f3c
arr2    new      3d3ee0
arr2----next
arr2----prev
arr1   3d3f48    3d3f4c
arr2    new      3d3ee8
arr2----next
arr2----prev
arr1   3d3f58    3d3f5c
arr2    new      3d3ef0
arr2----next
main   3d3ed8    3d3f28    0
main   3d3ed8    3d3f2c    1
main   3d3ee0    3d3f38    2
main   3d3ee0    3d3f3c    3
main   3d3ee8    3d3f48    4
main   3d3ee8    3d3f4c    5
main   3d3ef0    3d3f58    6
main   3d3ef0    3d3f5c    7
3
Array2
Array1
Array1
Array1
Array1

--------------------------------
Process exited after 2.14 seconds with return value 0
Ϸ ƹ Ű ʽÿ . . .


#endif



